-- Set Variables
soh = "HIDDEN"

-- Initialisierung beim Login 
local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame:SetScript("OnEvent", function(self,event,...) 

	if type(Finifi_Interrupt_Data) ~= "table" then
		Finifi_Interrupt_Data = {}
		Finifi_Interrupt_Data['out_msg_default'] = '[TARGET_SPELL] from [TARGET] interrupted with [SOURCE_SPELL]!'
		Finifi_Interrupt_Data['out_msg'] = Finifi_Interrupt_Data['out_msg_default']
		Finifi_Interrupt_Data['out_type'] = 'SELF'
		Finifi_Interrupt_Data['toggle'] = 'ON'
	end
	
	if type(Finifi_Interrupt_Data['out_msg']) == 'nil' then
		Finifi_Interrupt_Data['out_msg'] = Finifi_Interrupt_Data['out_msg_default']
	end
	
	if type(Finifi_Interrupt_Data['out_type']) == 'nil' then
		Finifi_Interrupt_Data['out_type'] = "SELF"
	end
	
	if type(Finifi_Interrupt_Data['toggle']) == 'nil' then
		Finifi_Interrupt_Data['toggle'] = 'ON'
	end
	
	if type(Finifi_Interrupt_Data['out_msg_default']) == 'nil' then
		Finifi_Interrupt_Data['out_msg_default'] = '[TARGET_SPELL] from [TARGET] interrupted with [SOURCE_SPELL]!'
	end
	
	if Finifi_Interrupt_Data['toggle'] == 'OFF' then
		ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: |cffFF0000Deactivated|cffFFFFFF.')
	else
		ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: |cff00FF00Activated|cffFFFFFF.')
	end
	
	ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Output chat: "' .. Finifi_Interrupt_Data['out_type'] .. '".')
	FIIA_Frame:SetPoint("CENTER")
end)


-- Befehl erstellen und auswerten
SLASH_FIc1 = '/fiia'
function SlashCmdList.FIc(msg, editBox)
	local cmd = string.upper(string.match(msg, '^([^%s]*)'))
	local rst = string.match(msg, '^[^%s]*%s(.*)$')
	
	if cmd == 'SELF' or cmd == 'SAY' or cmd == 'YELL' or cmd == 'PARTY' or cmd == 'RAID' or cmd == 'GUILD' or cmd == 'OFFICER' then
		Finifi_Interrupt_Data['out_type'] = cmd
		ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Output chat changed to "' .. Finifi_Interrupt_Data['out_type'] .. '".')
		
	elseif cmd == 'MSG' then
		if type(rst) == 'nil' then
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: No Message given')
			
		elseif strlower(rst) == 'default' then
			Finifi_Interrupt_Data['out_msg'] = Finifi_Interrupt_Data['out_msg_default']
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Output message changed to "' .. Finifi_Interrupt_Data['out_msg'] .. '".')
		
		else
			Finifi_Interrupt_Data['out_msg'] = rst
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Output message changed to "' .. Finifi_Interrupt_Data['out_msg'] .. '".')
		
		end
	
	elseif cmd == 'TOGGLE' then
		if Finifi_Interrupt_Data['toggle'] == 'ON' then
			Finifi_Interrupt_Data['toggle'] = 'OFF'
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: |cffFF0000Deactivated|cffFFFFFF.')
		
		else
			Finifi_Interrupt_Data['toggle'] = 'ON'
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: |cff00FF00Activated|cffFFFFFF.')
		
		end
	
	elseif cmd == 'HELP' then
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: /fi')
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: /fi toggle')
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: /fi SELF | SAY | YELL | PARTY | RAID | GUILD | OFFICER')
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: /fi msg (MESSAGE | default)')
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Varaibles that can be used in the message:')
			ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: [TARGET], [TARGET_SPELL], [SOURCE], [SOURCE_SPELL]')
	
	elseif cmd == '' or cmd == nil then
		if soh == 'HIDDEN' then
			FIIA_Frame:Show()
			soh = "SHOWN"
		else
			FIIA_Frame:Hide()
			soh = "HIDDEN"
		end
	
	else
		ChatFrame1:AddMessage('|cffFFA500FIIA|cffFFFFFF: Command "' .. cmd .. '" not found.')
		
	end
end


-- Event handeln
FIIA = {}
FIIA.frame = CreateFrame("frame")
FIIA.frame:Hide()
FIIA.frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
FIIA.frame:SetScript("OnEvent", function (self, event, ...) FIIA.handler(event, ...) end)
function FIIA.handler(event, ...)
	local event_type = select(2,...)
	if (event_type == "SPELL_INTERRUPT")  then
	
		if Finifi_Interrupt_Data['toggle'] ~= 'ON' then
			return
		end
		
		local source = select(5, ...)
		local source_spellid = select(12, ...)
		local target = select(9, ...)
		local target_spellid = select(15, ...)
			
		if source ~= UnitName("Player") then
			return
		end
			
		local msg = string.gsub(string.gsub(string.gsub(string.gsub(Finifi_Interrupt_Data['out_msg'], '%[TARGET%]', target), '%[TARGET_SPELL%]', GetSpellLink(target_spellid)), '%[SOURCE%]', source), '%[SOURCE_SPELL%]', GetSpellLink(source_spellid))
			
		if Finifi_Interrupt_Data['out_type'] == 'SELF' then 
			ChatFrame1:AddMessage(msg)
		else
			SendChatMessage(msg, Finifi_Interrupt_Data['out_type'])
		end
	end
end